'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var styled = require('styled-components');
var classNames = require('classnames');
var reactFontawesome = require('@fortawesome/react-fontawesome');
var fontawesomeSvgCore = require('@fortawesome/fontawesome-svg-core');
var freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');
var axios = require('axios');
var reactTransitionGroup = require('react-transition-group');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var styled__default = /*#__PURE__*/_interopDefaultLegacy(styled);
var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var axios__default = /*#__PURE__*/_interopDefaultLegacy(axios);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var ButtonContent = styled__default['default'].button(templateObject_1$g || (templateObject_1$g = __makeTemplateObject(["\n  border: none;\n  border: 1px solid #0d6efd;\n  background: #0d6efd;\n  border-radius: 2px;\n  padding: 0px 15px;\n  font-size: 14px;\n  min-height: 36px;\n  font-weight: 400;\n  color: #fff;\n  transition: all 0.3s ease-in 0s;\n  &:hover {\n    box-shadow: 3px 3px 5px rgba(0, 0, 0, 0.25);\n    cursor: pointer;\n  }\n  &.btn-small {\n    font-size: 12px;\n    padding: 0 10px;\n    min-height: 26px;\n  }\n  &.btn-large {\n    min-height: 46px;\n    font-size: 16px;\n  }\n  &.disabled {\n    box-shadow: none !important;\n    cursor: default;\n    opacity: 0.4;\n  }\n  &.btn-primary {\n    background-color: #0d6efd;\n    border-color: #0d6efd;\n    &.hollow {\n      background-color: transparent;\n      color: #0d6efd;\n    }\n  }\n  &.btn-success {\n    background-color: #198754;\n    border-color: #198754;\n    &.hollow {\n      background-color: transparent;\n      color: #198754;\n    }\n  }\n  &.btn-info {\n    background-color: #0dcaf0;\n    border-color: #0dcaf0;\n    &.hollow {\n      background-color: transparent;\n      color: #0dcaf0;\n    }\n  }\n  &.btn-warning {\n    background-color: #ffc107;\n    border-color: #ffc107;\n    &.hollow {\n      background-color: transparent;\n      color: #ffc107;\n    }\n  }\n  &.btn-danger {\n    background-color: #dc3545;\n    border-color: #dc3545;\n    &.hollow {\n      background-color: transparent;\n      color: #dc3545;\n    }\n  }\n  &.btn-light {\n    background-color: #f8f9fa;\n    border-color: #f8f9fa;\n    color: #333;\n  }\n  &.btn-dark {\n    background-color: #212529;\n    border-color: #212529;\n    &.hollow {\n      background-color: transparent;\n      color: #212529;\n    }\n  }\n\n  &.btn-solid {\n    border: 1px solid #3c64b1;\n    background-color: #3c64b1;\n    color: #fff;\n    &:hover {\n      box-shadow: rgb(0, 0, 0, 0.25) 0px 4px 4px;\n    }\n  }\n"], ["\n  border: none;\n  border: 1px solid #0d6efd;\n  background: #0d6efd;\n  border-radius: 2px;\n  padding: 0px 15px;\n  font-size: 14px;\n  min-height: 36px;\n  font-weight: 400;\n  color: #fff;\n  transition: all 0.3s ease-in 0s;\n  &:hover {\n    box-shadow: 3px 3px 5px rgba(0, 0, 0, 0.25);\n    cursor: pointer;\n  }\n  &.btn-small {\n    font-size: 12px;\n    padding: 0 10px;\n    min-height: 26px;\n  }\n  &.btn-large {\n    min-height: 46px;\n    font-size: 16px;\n  }\n  &.disabled {\n    box-shadow: none !important;\n    cursor: default;\n    opacity: 0.4;\n  }\n  &.btn-primary {\n    background-color: #0d6efd;\n    border-color: #0d6efd;\n    &.hollow {\n      background-color: transparent;\n      color: #0d6efd;\n    }\n  }\n  &.btn-success {\n    background-color: #198754;\n    border-color: #198754;\n    &.hollow {\n      background-color: transparent;\n      color: #198754;\n    }\n  }\n  &.btn-info {\n    background-color: #0dcaf0;\n    border-color: #0dcaf0;\n    &.hollow {\n      background-color: transparent;\n      color: #0dcaf0;\n    }\n  }\n  &.btn-warning {\n    background-color: #ffc107;\n    border-color: #ffc107;\n    &.hollow {\n      background-color: transparent;\n      color: #ffc107;\n    }\n  }\n  &.btn-danger {\n    background-color: #dc3545;\n    border-color: #dc3545;\n    &.hollow {\n      background-color: transparent;\n      color: #dc3545;\n    }\n  }\n  &.btn-light {\n    background-color: #f8f9fa;\n    border-color: #f8f9fa;\n    color: #333;\n  }\n  &.btn-dark {\n    background-color: #212529;\n    border-color: #212529;\n    &.hollow {\n      background-color: transparent;\n      color: #212529;\n    }\n  }\n\n  &.btn-solid {\n    border: 1px solid #3c64b1;\n    background-color: #3c64b1;\n    color: #fff;\n    &:hover {\n      box-shadow: rgb(0, 0, 0, 0.25) 0px 4px 4px;\n    }\n  }\n"])));
var Button = React.memo(function (props) {
    var _a;
    var children = props.children, className = props.className, disabled = props.disabled, size = props.size, buttonType = props.buttonType, hollow = props.hollow, restProps = __rest(props, ["children", "className", "disabled", "size", "buttonType", "hollow"]);
    var classes = classNames__default['default'](className, (_a = {},
        _a["btn-" + size] = size,
        _a["btn-" + buttonType] = buttonType,
        _a.disabled = disabled || undefined,
        _a.hollow = hollow,
        _a));
    return (
    // eslint-disable-next-line react/jsx-props-no-spreading
    React__default['default'].createElement(ButtonContent, __assign({ disabled: disabled, className: classes }, restProps), children));
});
var templateObject_1$g;

var CardContent = styled__default['default'].div(templateObject_1$f || (templateObject_1$f = __makeTemplateObject(["\n  background: #fff;\n  box-shadow: 0px 3px 10px rgba(0, 0, 0, 0.1);\n  border-radius: 6px;\n  padding: 20px;\n  transition: 0.2s all ease-in;\n  cursor: pointer;\n  &:hover {\n    transform: translateY(-2px);\n  }\n  &.disabled {\n    cursor: default;\n    &:hover {\n      transform: none;\n    }\n  }\n"], ["\n  background: #fff;\n  box-shadow: 0px 3px 10px rgba(0, 0, 0, 0.1);\n  border-radius: 6px;\n  padding: 20px;\n  transition: 0.2s all ease-in;\n  cursor: pointer;\n  &:hover {\n    transform: translateY(-2px);\n  }\n  &.disabled {\n    cursor: default;\n    &:hover {\n      transform: none;\n    }\n  }\n"])));
var Card = function (_a) {
    var className = _a.className, style = _a.style, children = _a.children, onClick = _a.onClick, disabled = _a.disabled;
    var handelClick = function () {
        if (onClick) {
            onClick();
        }
    };
    var classes = classNames__default['default'](className, {
        disabled: disabled,
    });
    return (React__default['default'].createElement(CardContent, { className: classes, style: style, onClick: handelClick }, children));
};
var templateObject_1$f;

var InputContent = styled__default['default'].div(templateObject_1$e || (templateObject_1$e = __makeTemplateObject(["\n  /* display: inline-block; */\n  border: 1px solid #f4f5f4;\n  border-radius: 3px;\n  background: #f4f5f4;\n  padding: 0 10px;\n  height: 38px;\n  transition: all 0.4s ease-in;\n  &.focus,\n  &:hover {\n    border: 1px solid #3c64b1;\n  }\n  &.disabled,\n  &.disabled:hover {\n    opacity: 0.5;\n    border: 1px solid rgb(205, 205, 205);\n  }\n  &.wrong {\n    border-color: red !important;\n  }\n  &.input-small {\n    height: 38px;\n  }\n  &.input-large {\n    height: 44px;\n  }\n  .i-content {\n    height: 100%;\n    display: flex;\n    flex-direction: row;\n    align-items: center;\n    min-width: auto;\n    .l {\n      margin-right: 10px;\n    }\n    .r {\n      margin-left: 10px;\n    }\n    .l,\n    .r {\n      color: #333;\n    }\n    input {\n      outline: none;\n      flex: 1;\n      background: none;\n      height: 100%;\n      border: none;\n      font-size: 14px;\n      width: 100%;\n      &::placeholder {\n        color: 737b7d;\n      }\n    }\n  }\n"], ["\n  /* display: inline-block; */\n  border: 1px solid #f4f5f4;\n  border-radius: 3px;\n  background: #f4f5f4;\n  padding: 0 10px;\n  height: 38px;\n  transition: all 0.4s ease-in;\n  &.focus,\n  &:hover {\n    border: 1px solid #3c64b1;\n  }\n  &.disabled,\n  &.disabled:hover {\n    opacity: 0.5;\n    border: 1px solid rgb(205, 205, 205);\n  }\n  &.wrong {\n    border-color: red !important;\n  }\n  &.input-small {\n    height: 38px;\n  }\n  &.input-large {\n    height: 44px;\n  }\n  .i-content {\n    height: 100%;\n    display: flex;\n    flex-direction: row;\n    align-items: center;\n    min-width: auto;\n    .l {\n      margin-right: 10px;\n    }\n    .r {\n      margin-left: 10px;\n    }\n    .l,\n    .r {\n      color: #333;\n    }\n    input {\n      outline: none;\n      flex: 1;\n      background: none;\n      height: 100%;\n      border: none;\n      font-size: 14px;\n      width: 100%;\n      &::placeholder {\n        color: 737b7d;\n      }\n    }\n  }\n"])));
var Input = function (props) {
    var _a;
    var disabled = props.disabled, className = props.className, leftContent = props.leftContent, rightContent = props.rightContent, size = props.size, onFocus = props.onFocus, onBlur = props.onBlur, wrong = props.wrong, style = props.style, restProps = __rest(props, ["disabled", "className", "leftContent", "rightContent", "size", "onFocus", "onBlur", "wrong", "style"]);
    var _b = React.useState(false), focusIn = _b[0], setFocusIn = _b[1];
    var classes = classNames__default['default']((_a = {
            disabled: disabled
        },
        _a["input-" + size] = size,
        _a.focus = focusIn,
        _a.wrong = wrong,
        _a), className);
    var hancelFocus = function (e) {
        setFocusIn(true);
        onFocus && onFocus(e);
    };
    var handelBlur = function (e) {
        setFocusIn(false);
        onBlur && onBlur(e);
    };
    return (React__default['default'].createElement(InputContent, { className: classes, style: style },
        React__default['default'].createElement("div", { className: "i-content" },
            leftContent && React__default['default'].createElement("div", { className: "l" }, leftContent),
            React__default['default'].createElement("input", __assign({ onFocus: function (e) { return hancelFocus(e); }, onBlur: function (e) { return handelBlur(e); }, disabled: disabled }, restProps)),
            rightContent && React__default['default'].createElement("div", { className: "r" }, rightContent))));
};
var templateObject_1$e;

function createCommonjsModule(fn) {
  var module = { exports: {} };
	return fn(module, module.exports), module.exports;
}

/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}var AsyncMode=l;var ConcurrentMode=m;var ContextConsumer=k;var ContextProvider=h;var Element=c;var ForwardRef=n;var Fragment=e;var Lazy=t;var Memo=r;var Portal=d;
var Profiler=g;var StrictMode=f;var Suspense=p;var isAsyncMode=function(a){return A(a)||z(a)===l};var isConcurrentMode=A;var isContextConsumer=function(a){return z(a)===k};var isContextProvider=function(a){return z(a)===h};var isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};var isForwardRef=function(a){return z(a)===n};var isFragment=function(a){return z(a)===e};var isLazy=function(a){return z(a)===t};
var isMemo=function(a){return z(a)===r};var isPortal=function(a){return z(a)===d};var isProfiler=function(a){return z(a)===g};var isStrictMode=function(a){return z(a)===f};var isSuspense=function(a){return z(a)===p};
var isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};var typeOf=z;

var reactIs_production_min = {
	AsyncMode: AsyncMode,
	ConcurrentMode: ConcurrentMode,
	ContextConsumer: ContextConsumer,
	ContextProvider: ContextProvider,
	Element: Element,
	ForwardRef: ForwardRef,
	Fragment: Fragment,
	Lazy: Lazy,
	Memo: Memo,
	Portal: Portal,
	Profiler: Profiler,
	StrictMode: StrictMode,
	Suspense: Suspense,
	isAsyncMode: isAsyncMode,
	isConcurrentMode: isConcurrentMode,
	isContextConsumer: isContextConsumer,
	isContextProvider: isContextProvider,
	isElement: isElement,
	isForwardRef: isForwardRef,
	isFragment: isFragment,
	isLazy: isLazy,
	isMemo: isMemo,
	isPortal: isPortal,
	isProfiler: isProfiler,
	isStrictMode: isStrictMode,
	isSuspense: isSuspense,
	isValidElementType: isValidElementType,
	typeOf: typeOf
};

/** @license React v16.13.1
 * react-is.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var reactIs_development = createCommonjsModule(function (module, exports) {



if (process.env.NODE_ENV !== "production") {
  (function() {

// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
// nor polyfill, then a plain number is used for performance.
var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
// (unstable) APIs that have been removed. Can we remove the symbols?

var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

function isValidElementType(type) {
  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
}

function typeOf(object) {
  if (typeof object === 'object' && object !== null) {
    var $$typeof = object.$$typeof;

    switch ($$typeof) {
      case REACT_ELEMENT_TYPE:
        var type = object.type;

        switch (type) {
          case REACT_ASYNC_MODE_TYPE:
          case REACT_CONCURRENT_MODE_TYPE:
          case REACT_FRAGMENT_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_SUSPENSE_TYPE:
            return type;

          default:
            var $$typeofType = type && type.$$typeof;

            switch ($$typeofType) {
              case REACT_CONTEXT_TYPE:
              case REACT_FORWARD_REF_TYPE:
              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PROVIDER_TYPE:
                return $$typeofType;

              default:
                return $$typeof;
            }

        }

      case REACT_PORTAL_TYPE:
        return $$typeof;
    }
  }

  return undefined;
} // AsyncMode is deprecated along with isAsyncMode

var AsyncMode = REACT_ASYNC_MODE_TYPE;
var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
var ContextConsumer = REACT_CONTEXT_TYPE;
var ContextProvider = REACT_PROVIDER_TYPE;
var Element = REACT_ELEMENT_TYPE;
var ForwardRef = REACT_FORWARD_REF_TYPE;
var Fragment = REACT_FRAGMENT_TYPE;
var Lazy = REACT_LAZY_TYPE;
var Memo = REACT_MEMO_TYPE;
var Portal = REACT_PORTAL_TYPE;
var Profiler = REACT_PROFILER_TYPE;
var StrictMode = REACT_STRICT_MODE_TYPE;
var Suspense = REACT_SUSPENSE_TYPE;
var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

function isAsyncMode(object) {
  {
    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    }
  }

  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
}
function isConcurrentMode(object) {
  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
}
function isContextConsumer(object) {
  return typeOf(object) === REACT_CONTEXT_TYPE;
}
function isContextProvider(object) {
  return typeOf(object) === REACT_PROVIDER_TYPE;
}
function isElement(object) {
  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
}
function isForwardRef(object) {
  return typeOf(object) === REACT_FORWARD_REF_TYPE;
}
function isFragment(object) {
  return typeOf(object) === REACT_FRAGMENT_TYPE;
}
function isLazy(object) {
  return typeOf(object) === REACT_LAZY_TYPE;
}
function isMemo(object) {
  return typeOf(object) === REACT_MEMO_TYPE;
}
function isPortal(object) {
  return typeOf(object) === REACT_PORTAL_TYPE;
}
function isProfiler(object) {
  return typeOf(object) === REACT_PROFILER_TYPE;
}
function isStrictMode(object) {
  return typeOf(object) === REACT_STRICT_MODE_TYPE;
}
function isSuspense(object) {
  return typeOf(object) === REACT_SUSPENSE_TYPE;
}

exports.AsyncMode = AsyncMode;
exports.ConcurrentMode = ConcurrentMode;
exports.ContextConsumer = ContextConsumer;
exports.ContextProvider = ContextProvider;
exports.Element = Element;
exports.ForwardRef = ForwardRef;
exports.Fragment = Fragment;
exports.Lazy = Lazy;
exports.Memo = Memo;
exports.Portal = Portal;
exports.Profiler = Profiler;
exports.StrictMode = StrictMode;
exports.Suspense = Suspense;
exports.isAsyncMode = isAsyncMode;
exports.isConcurrentMode = isConcurrentMode;
exports.isContextConsumer = isContextConsumer;
exports.isContextProvider = isContextProvider;
exports.isElement = isElement;
exports.isForwardRef = isForwardRef;
exports.isFragment = isFragment;
exports.isLazy = isLazy;
exports.isMemo = isMemo;
exports.isPortal = isPortal;
exports.isProfiler = isProfiler;
exports.isStrictMode = isStrictMode;
exports.isSuspense = isSuspense;
exports.isValidElementType = isValidElementType;
exports.typeOf = typeOf;
  })();
}
});

var reactIs = createCommonjsModule(function (module) {

if (process.env.NODE_ENV === 'production') {
  module.exports = reactIs_production_min;
} else {
  module.exports = reactIs_development;
}
});

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret$1 = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret$1;

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var printWarning$1 = function() {};

if (process.env.NODE_ENV !== 'production') {
  var ReactPropTypesSecret = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};
  var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);

  printWarning$1 = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
  if (process.env.NODE_ENV !== 'production') {
    for (var typeSpecName in typeSpecs) {
      if (has$1(typeSpecs, typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error(
              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
            );
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning$1(
            (componentName || 'React class') + ': type specification of ' +
            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
            'You may have forgotten to pass an argument to the type checker ' +
            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
            'shape all require an argument).'
          );
        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning$1(
            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
          );
        }
      }
    }
  }
}

/**
 * Resets warning cache when testing.
 *
 * @private
 */
checkPropTypes.resetWarningCache = function() {
  if (process.env.NODE_ENV !== 'production') {
    loggedTypeFailures = {};
  }
};

var checkPropTypes_1 = checkPropTypes;

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */







var has = Function.call.bind(Object.prototype.hasOwnProperty);
var printWarning = function() {};

if (process.env.NODE_ENV !== 'production') {
  printWarning = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    elementType: createElementTypeTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker,
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    if (process.env.NODE_ENV !== 'production') {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret_1) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error(
            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
            'Use `PropTypes.checkPropTypes()` to call them. ' +
            'Read more at http://fb.me/use-check-prop-types'
          );
          err.name = 'Invariant Violation';
          throw err;
        } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (
            !manualPropTypeCallCache[cacheKey] &&
            // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3
          ) {
            printWarning(
              'You are manually calling a React.PropTypes validation ' +
              'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
              'and will throw in the standalone `prop-types` package. ' +
              'You may be seeing this warning due to a third-party PropTypes ' +
              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
            );
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!reactIs.isValidElementType(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      if (process.env.NODE_ENV !== 'production') {
        if (arguments.length > 1) {
          printWarning(
            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
          );
        } else {
          printWarning('Invalid argument supplied to oneOf, expected an array.');
        }
      }
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
        var type = getPreciseType(value);
        if (type === 'symbol') {
          return String(value);
        }
        return value;
      });
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (has(propValue, key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      process.env.NODE_ENV !== 'production' ? printWarning('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning(
          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
        );
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = objectAssign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError(
            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
          );
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // falsy value can't be a Symbol
    if (!propValue) {
      return false;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue;
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes_1;
  ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */



function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

var factoryWithThrowingShims = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret_1) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  }  shim.isRequired = shim;
  function getShim() {
    return shim;
  }  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var propTypes = createCommonjsModule(function (module) {
if (process.env.NODE_ENV !== 'production') {
  var ReactIs = reactIs;

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = factoryWithThrowingShims();
}
});

var BreadcrumbContent = styled__default['default'].div(templateObject_1$d || (templateObject_1$d = __makeTemplateObject(["\n  font-size: 14px;\n  color: #555;\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  span {\n    display: inline-block;\n    color: #777;\n    &::after {\n      display: inline;\n      content: '/';\n      margin: 0 10px;\n      color: #999;\n    }\n    &:last-child::after {\n      content: '';\n      margin: 0 0px;\n    }\n  }\n  a {\n    color: #555;\n    text-decoration: none;\n    :hover {\n      color: #0d6efd;\n    }\n  }\n"], ["\n  font-size: 14px;\n  color: #555;\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  span {\n    display: inline-block;\n    color: #777;\n    &::after {\n      display: inline;\n      content: '/';\n      margin: 0 10px;\n      color: #999;\n    }\n    &:last-child::after {\n      content: '';\n      margin: 0 0px;\n    }\n  }\n  a {\n    color: #555;\n    text-decoration: none;\n    :hover {\n      color: #0d6efd;\n    }\n  }\n"])));
var templateObject_1$d;

var Breadcrumb = function (props) {
    var className = props.className, children = props.children, style = props.style, restProps = __rest(props, ["className", "children", "style"]);
    var renderItem = function () {
        return React__default['default'].Children.map(children, function (child) {
            console.log(child);
            return child;
        });
    };
    return (React__default['default'].createElement(BreadcrumbContent, __assign({ className: className, style: style }, restProps),
        React__default['default'].createElement("div", null, renderItem())));
};
Breadcrumb.propTypes = {
    className: propTypes.string,
    style: propTypes.object,
    children: propTypes.any,
};

var BreadItem = function (props) {
    // eslint-disable-next-line react/prop-types
    var children = props.children;
    return React__default['default'].createElement("span", null, children);
};

var Breadcrumbs = Breadcrumb;
Breadcrumbs.Item = BreadItem;

fontawesomeSvgCore.library.add(freeSolidSvgIcons.fas);
var Icon = function (props) {
    var restProps = __rest(props, []);
    return React__default['default'].createElement(reactFontawesome.FontAwesomeIcon, __assign({}, restProps));
};

var NoContentBox = styled__default['default'].div(templateObject_1$c || (templateObject_1$c = __makeTemplateObject(["\n  padding: 100px 30px;\n  text-align: center;\n  p {\n    font-size: 15px;\n    padding: 20px 0;\n    color: #888;\n  }\n"], ["\n  padding: 100px 30px;\n  text-align: center;\n  p {\n    font-size: 15px;\n    padding: 20px 0;\n    color: #888;\n  }\n"])));
var NoContent = function (_a) {
    var messageText = _a.messageText, icon = _a.icon, size = _a.size, restProps = __rest(_a, ["messageText", "icon", "size"]);
    return (React__default['default'].createElement(NoContentBox, null,
        React__default['default'].createElement("div", null,
            React__default['default'].createElement(Icon, __assign({ icon: icon || 'file-code', size: size || '4x', color: "#ccc" }, restProps))),
        React__default['default'].createElement("p", null, messageText)));
};
NoContent.defaultProps = {
    messageText: '暂无数据',
};
var templateObject_1$c;

var RaidoContent = styled__default['default'].div(templateObject_1$b || (templateObject_1$b = __makeTemplateObject(["\n  display: inline-block;\n  position: relative;\n  padding-left: 30px;\n  line-height: 20px;\n  height: 20px;\n  cursor: pointer;\n  &::before {\n    content: '';\n    display: inline-block;\n    width: 20px;\n    height: 20px;\n    border: 2px solid #c3cbcd;\n    box-sizing: border-box;\n    border-radius: 100px;\n    vertical-align: middle;\n    position: absolute;\n    top: 0;\n    left: 0;\n  }\n  &.disabled {\n    opacity: 0.5;\n    cursor: default;\n  }\n  &.checked {\n    &::before {\n      transition: all 0.3s ease-in;\n      border: 2px solid #3c64b1;\n    }\n    &::after {\n      position: absolute;\n      top: 5px;\n      left: 5px;\n      display: inline-block;\n      content: '';\n      width: 10px;\n      height: 10px;\n      background: #3c64b1;\n      border-radius: 100%;\n    }\n  }\n"], ["\n  display: inline-block;\n  position: relative;\n  padding-left: 30px;\n  line-height: 20px;\n  height: 20px;\n  cursor: pointer;\n  &::before {\n    content: '';\n    display: inline-block;\n    width: 20px;\n    height: 20px;\n    border: 2px solid #c3cbcd;\n    box-sizing: border-box;\n    border-radius: 100px;\n    vertical-align: middle;\n    position: absolute;\n    top: 0;\n    left: 0;\n  }\n  &.disabled {\n    opacity: 0.5;\n    cursor: default;\n  }\n  &.checked {\n    &::before {\n      transition: all 0.3s ease-in;\n      border: 2px solid #3c64b1;\n    }\n    &::after {\n      position: absolute;\n      top: 5px;\n      left: 5px;\n      display: inline-block;\n      content: '';\n      width: 10px;\n      height: 10px;\n      background: #3c64b1;\n      border-radius: 100%;\n    }\n  }\n"])));
var Raido = function (props) {
    var children = props.children, className = props.className, disabled = props.disabled, checked = props.checked, onClick = props.onClick;
    var classes = classNames__default['default']('', className, {
        disabled: disabled,
        checked: checked,
    });
    var handelClick = function () {
        if (!disabled) {
            if (onClick) {
                onClick();
            }
        }
    };
    return (React__default['default'].createElement(RaidoContent, { onClick: handelClick, className: classes }, children));
};
var templateObject_1$b;

var StepsContainer = styled__default['default'].div(templateObject_1$a || (templateObject_1$a = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n  justify-content: space-between;\n  & > div {\n    /* border: 1px solid red; */\n    flex: 1;\n    /* display: flex; */\n    /* flex-direction: column; */\n    .top {\n      display: flex;\n      flex-direction: row;\n      align-items: center;\n      .disc {\n        display: inline-block;\n        border-radius: 20px;\n        max-width: 100px;\n        font-size: 15px;\n        color: #666;\n      }\n      .solid {\n        flex: 1;\n        height: 1px;\n        font-size: 0;\n        margin: 0 30px;\n        background-color: #ccc;\n      }\n    }\n    .content {\n      padding-top: 10px;\n      margin-right: 30px;\n      font-size: 14px;\n      line-height: 1.5;\n      color: #777;\n      max-width: 150px;\n    }\n    &:last-child {\n      flex: none;\n      .solid {\n        flex: none;\n        display: none;\n      }\n      .content {\n        margin-right: 0px;\n      }\n    }\n  }\n  & > div.actived {\n    .disc {\n      color: #0d6efd;\n    }\n    .solid {\n      background-color: #0d6efd;\n    }\n  }\n"], ["\n  display: flex;\n  flex-direction: row;\n  justify-content: space-between;\n  & > div {\n    /* border: 1px solid red; */\n    flex: 1;\n    /* display: flex; */\n    /* flex-direction: column; */\n    .top {\n      display: flex;\n      flex-direction: row;\n      align-items: center;\n      .disc {\n        display: inline-block;\n        border-radius: 20px;\n        max-width: 100px;\n        font-size: 15px;\n        color: #666;\n      }\n      .solid {\n        flex: 1;\n        height: 1px;\n        font-size: 0;\n        margin: 0 30px;\n        background-color: #ccc;\n      }\n    }\n    .content {\n      padding-top: 10px;\n      margin-right: 30px;\n      font-size: 14px;\n      line-height: 1.5;\n      color: #777;\n      max-width: 150px;\n    }\n    &:last-child {\n      flex: none;\n      .solid {\n        flex: none;\n        display: none;\n      }\n      .content {\n        margin-right: 0px;\n      }\n    }\n  }\n  & > div.actived {\n    .disc {\n      color: #0d6efd;\n    }\n    .solid {\n      background-color: #0d6efd;\n    }\n  }\n"])));
var templateObject_1$a;

/* eslint-disable react/prop-types */
var StepContent = function (props) {
    var children = props.children, className = props.className, col = props.col, selectIndex = props.selectIndex, style = props.style;
    var classes = classNames__default['default'](className, {
        col: col,
    });
    var renderItem = function () {
        return React__default['default'].Children.map(children, function (child, index) {
            var childElement = child;
            var stepTitle = childElement.props.stepTitle;
            return (React__default['default'].createElement("div", { className: "item " + (selectIndex >= index ? 'actived' : '') },
                React__default['default'].createElement("div", { className: 'top' },
                    React__default['default'].createElement("div", { className: 'disc' }, stepTitle),
                    React__default['default'].createElement("div", { className: 'solid' })),
                React__default['default'].createElement("div", { className: 'content' }, child)));
        });
    };
    return (React__default['default'].createElement(StepsContainer, { className: classes, style: style }, renderItem()));
};

var StepItem = function (_a) {
    var children = _a.children;
    return React__default['default'].createElement(React__default['default'].Fragment, null, children);
};

/* eslint-disable no-unused-vars */
var Steps = StepContent;
Steps.Item = StepItem;

var ImageContainer = styled__default['default'].div(templateObject_1$9 || (templateObject_1$9 = __makeTemplateObject(["\n  display: inline-block;\n  & > div {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    overflow: hidden;\n    img {\n      max-width: 100%;\n      max-height: 100%;\n      display: block;\n    }\n  }\n  &.hover {\n    div {\n      cursor: pointer;\n    }\n  }\n"], ["\n  display: inline-block;\n  & > div {\n    display: flex;\n    flex-direction: column;\n    justify-content: center;\n    align-items: center;\n    overflow: hidden;\n    img {\n      max-width: 100%;\n      max-height: 100%;\n      display: block;\n    }\n  }\n  &.hover {\n    div {\n      cursor: pointer;\n    }\n  }\n"])));
var Image = function (props) {
    var width = props.width, height = props.height, imUrl = props.imUrl, onClick = props.onClick, borderRadius = props.borderRadius, borderColor = props.borderColor, bgColor = props.bgColor, alt = props.alt, className = props.className;
    var classes = classNames__default['default'](className, {
        hover: onClick,
    });
    return (React__default['default'].createElement(ImageContainer, { className: classes, onClick: onClick },
        React__default['default'].createElement("div", { style: {
                width: width + "px",
                height: height + "px",
                border: "1px solid " + borderColor,
                borderRadius: borderRadius + "px",
                backgroundColor: "" + bgColor,
            } },
            React__default['default'].createElement("img", { alt: alt, src: imUrl }))));
};
Image.defaultProps = {
    width: 100,
    height: 100,
};
var templateObject_1$9;

var BubbleContent = styled__default['default'].div(templateObject_1$8 || (templateObject_1$8 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n  width: 70%;\n  padding: 5px 0;\n  .imx {\n    width: 36px;\n    margin-left: 0px;\n  }\n  .mess {\n    margin-left: 10px;\n    margin-right: 0px;\n    .name {\n      font-size: 12px;\n      line-height: 13px;\n      margin-bottom: 5px;\n      color: #777;\n    }\n    .msgbox {\n      background: #f1f0f0;\n      padding: 13px;\n      font-size: 12px;\n      line-height: 1.5;\n      border-radius: 0px 10px 10px 10px;\n      word-break: break-all;\n      white-space: normal;\n      color: #000;\n    }\n  }\n  &.roleAt {\n    flex-direction: row-reverse;\n    float: right;\n    .imx {\n      margin-right: 0px !important;\n    }\n    .mess {\n      margin-left: 0px;\n      margin-right: 10px;\n      .name {\n        text-align: right;\n      }\n      .msgbox {\n        background: #0084ff;\n        color: #fff;\n        border-radius: 10px 0px 10px 10px;\n      }\n    }\n  }\n"], ["\n  display: flex;\n  flex-direction: row;\n  width: 70%;\n  padding: 5px 0;\n  .imx {\n    width: 36px;\n    margin-left: 0px;\n  }\n  .mess {\n    margin-left: 10px;\n    margin-right: 0px;\n    .name {\n      font-size: 12px;\n      line-height: 13px;\n      margin-bottom: 5px;\n      color: #777;\n    }\n    .msgbox {\n      background: #f1f0f0;\n      padding: 13px;\n      font-size: 12px;\n      line-height: 1.5;\n      border-radius: 0px 10px 10px 10px;\n      word-break: break-all;\n      white-space: normal;\n      color: #000;\n    }\n  }\n  &.roleAt {\n    flex-direction: row-reverse;\n    float: right;\n    .imx {\n      margin-right: 0px !important;\n    }\n    .mess {\n      margin-left: 0px;\n      margin-right: 10px;\n      .name {\n        text-align: right;\n      }\n      .msgbox {\n        background: #0084ff;\n        color: #fff;\n        border-radius: 10px 0px 10px 10px;\n      }\n    }\n  }\n"])));
var Bubble = function (props) {
    var imUrl = props.imUrl, roleAt = props.roleAt, messageText = props.messageText, userName = props.userName, restProps = __rest(props, ["imUrl", "roleAt", "messageText", "userName"]);
    var classes = classNames__default['default']('', {
        roleAt: roleAt,
    });
    return (React__default['default'].createElement(BubbleContent, { className: classes },
        React__default['default'].createElement("div", { className: "im" },
            React__default['default'].createElement(Image, __assign({ height: 36, width: 36, borderRadius: 36, imUrl: imUrl }, restProps))),
        React__default['default'].createElement("div", { className: "mess" },
            React__default['default'].createElement("p", { className: "name" }, userName),
            React__default['default'].createElement("div", { className: "msgbox" }, messageText))));
};
Bubble.defaultProps = {
    roleAt: false,
};
var templateObject_1$8;

var GlobalStyle = styled.createGlobalStyle(templateObject_1$7 || (templateObject_1$7 = __makeTemplateObject(["\n*{margin:0;padding:0;-webkit-box-sizing:border-box;\n  -moz-box-sizing:border-box;box-sizing:border-box;}\ninput,button,select,textarea{ outline:none; }\ninput{-webkit-appearance : none ; }\nhtml{background:#fff;overflow:auto;}\nbody{font:14px/18px PingFang SC,\"Hiragino Sans GB\",\n\"Microsoft Yahei\",SimSun,Arial,\"Helvetica Neue\",Helvetica,Lantinghei SC;\ncolor:#333; -webkit-font-smoothing: antialiased;}\nbody, html{ background: #f4f4f4; }\na{color:#333; text-decoration:none; cursor:pointer; outline: 0 none;}\n/* a:hover{ text-decoration:none;color:#ff4f20;} */\n/* a:focus{-moz-outline-style: none; border:0px; blur:expression(this.onFocus=this.blur());} */\nbody,div,dl,dt,dd,ul,ol,li,h1,h2,h3,h4,h5,h6,pre,code,form,fieldset,legend,\ninput,p,blockquote,th,td{margin:0; padding:0;}\nheader,footer,article,aside,section,nav,menu,hgroup,details,dialog,figure,figcaption{display:block}\nol,li,ul,dl,dt,dd{list-style:none;}\nfieldset,img {border:0}\ndiv,p,span{ outline: none }\nbutton,submit,input,select { vertical-align:middle;}\nbutton,submit { cursor:pointer;}\n/* h1,h2,h3,h4,h5,h6{font-size:inherit; font-weight:lighter;} */\ntable{border-collapse:collapse; border-spacing:0;}\nsup{vertical-align:text-top;}\nsub{vertical-align:text-bottom;}\nselect,button{font-family:inherit; font-size:inherit;\n   outline-style:none; outline-width:0pt; padding: 0; margin: 0;}/*font-weight:lighter;*/\nb,em,i{display:inline-block; font-weight:normal; font-style:normal;}\n::-webkit-input-placeholder {color:#ccc;}\n:-moz-placeholder {color:#ccc;}\n::-moz-placeholder {color:#ccc;}\n:-ms-input-placeholder {color:#ccc;}\n"], ["\n*{margin:0;padding:0;-webkit-box-sizing:border-box;\n  -moz-box-sizing:border-box;box-sizing:border-box;}\ninput,button,select,textarea{ outline:none; }\ninput{-webkit-appearance : none ; }\nhtml{background:#fff;overflow:auto;}\nbody{font:14px/18px PingFang SC,\"Hiragino Sans GB\",\n\"Microsoft Yahei\",SimSun,Arial,\"Helvetica Neue\",Helvetica,Lantinghei SC;\ncolor:#333; -webkit-font-smoothing: antialiased;}\nbody, html{ background: #f4f4f4; }\na{color:#333; text-decoration:none; cursor:pointer; outline: 0 none;}\n/* a:hover{ text-decoration:none;color:#ff4f20;} */\n/* a:focus{-moz-outline-style: none; border:0px; blur:expression(this.onFocus=this.blur());} */\nbody,div,dl,dt,dd,ul,ol,li,h1,h2,h3,h4,h5,h6,pre,code,form,fieldset,legend,\ninput,p,blockquote,th,td{margin:0; padding:0;}\nheader,footer,article,aside,section,nav,menu,hgroup,details,dialog,figure,figcaption{display:block}\nol,li,ul,dl,dt,dd{list-style:none;}\nfieldset,img {border:0}\ndiv,p,span{ outline: none }\nbutton,submit,input,select { vertical-align:middle;}\nbutton,submit { cursor:pointer;}\n/* h1,h2,h3,h4,h5,h6{font-size:inherit; font-weight:lighter;} */\ntable{border-collapse:collapse; border-spacing:0;}\nsup{vertical-align:text-top;}\nsub{vertical-align:text-bottom;}\nselect,button{font-family:inherit; font-size:inherit;\n   outline-style:none; outline-width:0pt; padding: 0; margin: 0;}/*font-weight:lighter;*/\nb,em,i{display:inline-block; font-weight:normal; font-style:normal;}\n::-webkit-input-placeholder {color:#ccc;}\n:-moz-placeholder {color:#ccc;}\n::-moz-placeholder {color:#ccc;}\n:-ms-input-placeholder {color:#ccc;}\n"])));
var templateObject_1$7;

var TabsContent = styled__default['default'].div(templateObject_1$6 || (templateObject_1$6 = __makeTemplateObject(["\n  .tabs-nav {\n    display: flex;\n    flex-direction: row;\n    li {\n      font-size: 16px;\n      color: #222;\n      cursor: pointer;\n      font-weight: 500;\n      margin-right: 18px;\n      transition: all 0.2s ease-in;\n      &.actived {\n        color: rgb(0, 141, 223);\n      }\n      &.disabled {\n        opacity: 0.5;\n        cursor: not-allowed;\n        cursor: no-drop;\n      }\n    }\n  }\n  .tabs-content {\n  }\n"], ["\n  .tabs-nav {\n    display: flex;\n    flex-direction: row;\n    li {\n      font-size: 16px;\n      color: #222;\n      cursor: pointer;\n      font-weight: 500;\n      margin-right: 18px;\n      transition: all 0.2s ease-in;\n      &.actived {\n        color: rgb(0, 141, 223);\n      }\n      &.disabled {\n        opacity: 0.5;\n        cursor: not-allowed;\n        cursor: no-drop;\n      }\n    }\n  }\n  .tabs-content {\n  }\n"])));
var Tabs = function (props) {
    var children = props.children, className = props.className, defaultIndex = props.defaultIndex, onSelect = props.onSelect;
    var _a = React.useState(defaultIndex), activeIndex = _a[0], setActiveIndex = _a[1];
    var renderTabsNav = function () {
        return React__default['default'].Children.map(children, function (child, index) {
            var childElement = child;
            var _a = childElement.props, label = _a.label, disabled = _a.disabled;
            var tabClasses = classNames__default['default']({
                disabled: disabled,
                actived: activeIndex === index,
            });
            var handelClick = function () {
                if (!disabled) {
                    setActiveIndex(index);
                    if (onSelect) {
                        onSelect(index);
                    }
                }
            };
            return (React__default['default'].createElement("li", { role: "button", className: tabClasses, onClick: handelClick, onKeyPress: handelClick, tabIndex: 0 }, label));
        });
    };
    var renderTabsContent = function () {
        return React__default['default'].Children.map(children, function (child, index) {
            return activeIndex === index && child;
        });
    };
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement(TabsContent, { className: className },
            React__default['default'].createElement("ul", { className: "tabs-nav" }, renderTabsNav()),
            React__default['default'].createElement("div", { className: "tabs-conent" }, renderTabsContent())),
        React__default['default'].createElement(GlobalStyle, null)));
};
Tabs.defaultProps = {
    defaultIndex: 0,
};
var templateObject_1$6;

/* eslint-disable no-unused-vars */
var TabsItem = function (props) {
    var children = props.children;
    return React__default['default'].createElement(React__default['default'].Fragment, null, children);
};
TabsItem.propTypes = {
    label: propTypes.node,
    disabled: propTypes.bool,
    children: propTypes.node,
};

/* eslint-disable no-unused-vars */
var TransTabs = Tabs;
TransTabs.Item = TabsItem;

var MenuContent = styled__default['default'].ul(templateObject_1$5 || (templateObject_1$5 = __makeTemplateObject(["\n  display: flex;\n  position: relative;\n  z-index: 1;\n  background-color: #fff;\n  flex-direction: row;\n  height:44px;\n  > li.item{\n    height: 100%;\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    padding: 0 20px;\n    height: 100%;\n    font-size: 15px;\n    font-weight: 500;\n    cursor: pointer;\n    & > span{\n      display: flex;\n      align-items: center;\n      justify-content: center;\n      padding: 0 20px;\n      height: 100%;\n      font-size: 15px;\n      font-weight: 500;\n    }\n    &.disabled{\n      opacity: .5;\n      cursor: no-drop;\n    }\n    &.hover{\n      cursor: pointer;\n    }\n    &.actived::before{\n      position: absolute;\n      content:'';\n      bottom: 0;\n      left: 50%;\n      margin-left: -15px;\n      display: inline-block;\n      width: 30px;\n      height: 4px;\n      background-color:#0d6efd;\n      border-radius: 2px;\n    }\n    &.actived\n    {\n      color: #0d63fd;\n    }\n    & > .menu-subMenu{\n      position: absolute;\n      display: none;\n      z-index: 9;\n      top: 44px;\n      left: 0;\n      border: 1px solid #f1f1f1;\n        & > li{\n          color: #333;\n          min-width: 200px;\n          background-color: #fff;\n          /* white-space: nowrap; */\n          padding: 10px 16px;\n          font-weight: 400;\n          line-height: 1.5;\n          &:hover{\n            background-color: #f8f8f8;\n            transition: all .2s ease-in;\n          }\n          &.disabled{\n            color: #999;\n          }\n          &.disabled:hover{\n            background-color: #fff;\n            cursor: default;\n          }\n        }\n    }\n    &:hover .menu-subMenu{\n      display: block;\n    }\n  }\n"], ["\n  display: flex;\n  position: relative;\n  z-index: 1;\n  background-color: #fff;\n  flex-direction: row;\n  height:44px;\n  > li.item{\n    height: 100%;\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    padding: 0 20px;\n    height: 100%;\n    font-size: 15px;\n    font-weight: 500;\n    cursor: pointer;\n    & > span{\n      display: flex;\n      align-items: center;\n      justify-content: center;\n      padding: 0 20px;\n      height: 100%;\n      font-size: 15px;\n      font-weight: 500;\n    }\n    &.disabled{\n      opacity: .5;\n      cursor: no-drop;\n    }\n    &.hover{\n      cursor: pointer;\n    }\n    &.actived::before{\n      position: absolute;\n      content:'';\n      bottom: 0;\n      left: 50%;\n      margin-left: -15px;\n      display: inline-block;\n      width: 30px;\n      height: 4px;\n      background-color:#0d6efd;\n      border-radius: 2px;\n    }\n    &.actived\n    {\n      color: #0d63fd;\n    }\n    & > .menu-subMenu{\n      position: absolute;\n      display: none;\n      z-index: 9;\n      top: 44px;\n      left: 0;\n      border: 1px solid #f1f1f1;\n        & > li{\n          color: #333;\n          min-width: 200px;\n          background-color: #fff;\n          /* white-space: nowrap; */\n          padding: 10px 16px;\n          font-weight: 400;\n          line-height: 1.5;\n          &:hover{\n            background-color: #f8f8f8;\n            transition: all .2s ease-in;\n          }\n          &.disabled{\n            color: #999;\n          }\n          &.disabled:hover{\n            background-color: #fff;\n            cursor: default;\n          }\n        }\n    }\n    &:hover .menu-subMenu{\n      display: block;\n    }\n  }\n"])));
var templateObject_1$5;

var MenuContext = React.createContext({ index: '0' });
var Menu$1 = function (props) {
    var children = props.children, className = props.className, style = props.style, defaultActiveIndex = props.defaultActiveIndex, onSelect = props.onSelect;
    var _a = React.useState(defaultActiveIndex), activedIndex = _a[0], setActiveIndex = _a[1];
    var classes = classNames__default['default'](className, {});
    var handelClick = function (index) {
        setActiveIndex(index);
        if (onSelect) {
            onSelect(index);
        }
    };
    var passedContext = {
        index: activedIndex || '0',
        onSelect: handelClick,
    };
    var renderMenu = function () {
        return React__default['default'].Children.map(children, function (child, index) {
            var childElement = child;
            var displayName = childElement.type.displayName;
            if (displayName === 'MenuItem' || displayName === 'SubMenu') {
                return React__default['default'].cloneElement(childElement, {
                    index: index.toString(),
                });
            }
            return null;
        });
    };
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement(MenuContent, { style: style, className: classes },
            React__default['default'].createElement(MenuContext.Provider, { value: passedContext }, renderMenu())),
        React__default['default'].createElement(GlobalStyle, null)));
};

/* eslint-disable react/prop-types */
var MenuItem = function (props) {
    var index = props.index, disabled = props.disabled, className = props.className, children = props.children, style = props.style, onClick = props.onClick;
    var context = React.useContext(MenuContext);
    var classes = classNames__default['default']('item', className, {
        'disabled': disabled,
        'actived': context.index == index,
    });
    var handelClick = function () {
        if (!disabled && context.onSelect && typeof (index) === 'string') {
            context.onSelect(index);
            if (onClick) {
                onClick(index);
            }
        }
    };
    return (React__default['default'].createElement("li", { className: classes, onClick: handelClick, style: style }, children));
};

/* eslint-disable no-unused-vars */
var SubMenu = function (props) {
    var title = props.title, disabled = props.disabled, children = props.children, style = props.style, className = props.className, index = props.index;
    var context = React.useContext(MenuContext);
    var classes = classNames__default['default']('item', 'subMenuItem', className, {
        'disabled': disabled,
        'actived': index === context.index,
    });
    var renderSubMenu = function () {
        var ChildrenMap = React__default['default'].Children.map(children, function (child, i) {
            var childElement = child;
            var displayName = childElement.type.displayName;
            if (displayName === 'MenuItem') {
                return React__default['default'].cloneElement(childElement, {
                    index: index + "-" + i,
                });
            }
        });
        return (React__default['default'].createElement("ul", { className: "menu-subMenu" }, ChildrenMap));
    };
    var handelClick = function () {
        if (typeof (index) === 'string' && !disabled && context.onSelect) {
            context.onSelect(index);
        }
    };
    return (React__default['default'].createElement("li", { key: index, className: classes, style: style, onClick: handelClick },
        React__default['default'].createElement("div", null,
            title,
            " ",
            React__default['default'].createElement(Icon, { icon: "angle-down", className: "arrow-icon" })),
        renderSubMenu()));
};

var Menu = Menu$1;
Menu.Item = MenuItem;
Menu.SubMenu = SubMenu;

var SchoolSelectContent = styled__default['default'].div(templateObject_1$4 || (templateObject_1$4 = __makeTemplateObject(["\n  position: relative;\n  /* width: 400px; */\n  box-sizing: content-box;\n  .fetch-item-list,\n  .empty-item\n  {\n    position: absolute;\n    top: 40px;\n    width: 100%;\n    background-color: #fff;\n    z-index: 9;\n    font-size: 14px;\n    min-height: 40px;\n    border: 1px solid  #ccc;\n    .loading{\n      width: 100%;\n      display: block;\n      padding: 10px;\n      text-align: center;\n    }\n    & > li {\n      line-height: 1.5;\n      padding: 7px 10px;\n      &:hover{\n        cursor: pointer;\n        background-color: #f8f8f8;\n      }\n      &.actived{\n        background-color: #0d6efd;\n        color: #fff;\n      }\n      & >b{\n        color: #f73131;\n      }\n    }\n  }\n  .empty-item{\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    color: #757575;\n    padding: 10px;\n  }\n"], ["\n  position: relative;\n  /* width: 400px; */\n  box-sizing: content-box;\n  .fetch-item-list,\n  .empty-item\n  {\n    position: absolute;\n    top: 40px;\n    width: 100%;\n    background-color: #fff;\n    z-index: 9;\n    font-size: 14px;\n    min-height: 40px;\n    border: 1px solid  #ccc;\n    .loading{\n      width: 100%;\n      display: block;\n      padding: 10px;\n      text-align: center;\n    }\n    & > li {\n      line-height: 1.5;\n      padding: 7px 10px;\n      &:hover{\n        cursor: pointer;\n        background-color: #f8f8f8;\n      }\n      &.actived{\n        background-color: #0d6efd;\n        color: #fff;\n      }\n      & >b{\n        color: #f73131;\n      }\n    }\n  }\n  .empty-item{\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    color: #757575;\n    padding: 10px;\n  }\n"])));
var templateObject_1$4;

var LoadingContent = styled__default['default'].div(templateObject_1$3 || (templateObject_1$3 = __makeTemplateObject(["\n  display: inline-block;\n  position: relative;\n  z-index: 9999999;\n  & > .animateBox {\n    display: inline-block;\n    animation: rotate 1s infinite;\n    -webkit-animation: rotate 1s infinite;\n    @keyframes rotate {\n      0%{\n          transform:rotate(0deg);\n          -ms-transform:rotate(0deg);     /* IE 9 */\n          -moz-transform:rotate(0deg);    /* Firefox */\n          -o-transform:rotate(0deg);\n      }\n      100% {\n          transform:rotate(360deg);\n          -ms-transform:rotate(360deg);   /* IE 9 */\n          -moz-transform:rotate(360deg);  /* Firefox */\n          -o-transform:rotate(360deg);    \n      }\n    }\n  }\n  &.is-mask{\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    background: rgba(0, 0, 0, .3);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n  }\n  &.is-pos{\n    position: absolute;\n    z-index: 2;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n  }\n"], ["\n  display: inline-block;\n  position: relative;\n  z-index: 9999999;\n  & > .animateBox {\n    display: inline-block;\n    animation: rotate 1s infinite;\n    -webkit-animation: rotate 1s infinite;\n    @keyframes rotate {\n      0%{\n          transform:rotate(0deg);\n          -ms-transform:rotate(0deg);     /* IE 9 */\n          -moz-transform:rotate(0deg);    /* Firefox */\n          -o-transform:rotate(0deg);\n      }\n      100% {\n          transform:rotate(360deg);\n          -ms-transform:rotate(360deg);   /* IE 9 */\n          -moz-transform:rotate(360deg);  /* Firefox */\n          -o-transform:rotate(360deg);    \n      }\n    }\n  }\n  &.is-mask{\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    background: rgba(0, 0, 0, .3);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n  }\n  &.is-pos{\n    position: absolute;\n    z-index: 2;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n  }\n"])));
var Loading = function (props) {
    var size = props.size, color = props.color, mask = props.mask, absolute = props.absolute, className = props.className;
    var classes = classNames__default['default'](className, {
        'is-mask': mask,
        'is-pos': absolute,
    });
    return (React__default['default'].createElement(LoadingContent, { className: classes },
        React__default['default'].createElement("div", { className: "animateBox" },
            React__default['default'].createElement(Icon, { className: "", icon: "spinner", size: size || '2x', color: color }))));
};
var templateObject_1$3;

var SchoolSelect = function (props) {
    var className = props.className, style = props.style, defaultValue = props.defaultValue, onSelect = props.onSelect, emptyMessage = props.emptyMessage, restProps = __rest(props, ["className", "style", "defaultValue", "onSelect", "emptyMessage"]);
    var classes = classNames__default['default'](className, {});
    var _a = React.useState(defaultValue || ''), inputValue = _a[0], setInputValue = _a[1]; // value
    var _b = React.useState(false), onFocus = _b[0], setOnFocus = _b[1]; // 搜索列表是否为空
    var _c = React.useState(false), showLoading = _c[0], setShowLoading = _c[1]; // 查询第一级学校列表loading;
    var _d = React.useState([]), fetchScroolDataList = _d[0], setFetchSchoolDataList = _d[1]; // 查询到的学校列表
    var _e = React.useState(-1), schoolDataActive = _e[0], setSchoolDataActive = _e[1];
    var timer = null;
    // 第一步 输入关键词后查询学校列表；
    var onChangEvent = function (e) {
        var value = e.target.value;
        setInputValue(value);
        clearTimeout(Number(timer));
        setSchoolDataActive(-1);
        timer = setTimeout(function () {
            setShowLoading(true);
            axios__default['default'].get("http://smartschoolsearch.lockinu.com/suggest?search=" + value)
                .then(function (res) {
                if (res) {
                    var data = res.data;
                    if (data && data.length > 0) {
                        setOnFocus(false);
                    }
                    else {
                        setOnFocus(true);
                    }
                    setFetchSchoolDataList(data);
                }
                setShowLoading(false);
            })
                .catch(function (error) {
                setShowLoading(false);
                setOnFocus(true);
            });
        }, 500);
    };
    // 第二步 感觉当前学校名 查询学校详情;
    var fetchSchoolDetail = function (keyWords) {
        var words = encodeURI(keyWords === null || keyWords === void 0 ? void 0 : keyWords.replace(/<[^>]*>/g, ''));
        axios__default['default'].get("http://smartschoolsearch.lockinu.com/querySchool?search=" + words)
            .then(function (res) {
            var data = res.data;
            if (data) {
                setInputValue(data.schoolName);
                if (onSelect) {
                    onSelect(data);
                }
            }
        }).catch(function (error) {
            // console.log(error);
        });
    };
    // 设置学校查询列表为空
    var removeSchoolDataList = function () {
        setTimeout(function () {
            setFetchSchoolDataList([]);
        }, 200);
        setSchoolDataActive(-1);
    };
    // 键盘事件
    var keyDownCallback = function (e) {
        var _a;
        var key = e.key;
        if ((fetchScroolDataList === null || fetchScroolDataList === void 0 ? void 0 : fetchScroolDataList.length) > 0) {
            var length_1 = fetchScroolDataList.length;
            // 下键盘
            if (key === 'ArrowDown') {
                if (schoolDataActive === (length_1 - 1) || schoolDataActive == -1) {
                    setSchoolDataActive(0);
                }
                else {
                    setSchoolDataActive(schoolDataActive + 1);
                }
            }
            // 上键盘
            if (key === 'ArrowUp') {
                if (schoolDataActive === -1 || schoolDataActive === 0) {
                    setSchoolDataActive(length_1 - 1);
                }
                else {
                    setSchoolDataActive(schoolDataActive - 1);
                }
            }
            // 回车
            if (key === 'Enter' && schoolDataActive !== -1) {
                var selectWords = (_a = fetchScroolDataList[schoolDataActive]) === null || _a === void 0 ? void 0 : _a.term;
                fetchSchoolDetail(selectWords);
                removeSchoolDataList();
                // console.log(InputRef.current.value);
                var inputDom = document.getElementById('inputDom');
                if (inputDom) {
                    inputDom.blur();
                }
            }
        }
    };
    React.useEffect(function () {
        //
        return function () {
            clearTimeout(Number(timer));
        };
    }, []);
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement(SchoolSelectContent, { className: classes, style: style },
            React__default['default'].createElement(Input, __assign({ id: "inputDom", value: inputValue, onChange: function (e) { return onChangEvent(e); }, onKeyUp: keyDownCallback, onBlur: function () {
                    removeSchoolDataList();
                    setOnFocus(false);
                } }, restProps)),
            fetchScroolDataList &&
                fetchScroolDataList.length > 0 &&
                React__default['default'].createElement("ul", { className: "fetch-item-list" },
                    showLoading && React__default['default'].createElement(Loading, { className: "loading", size: "1x", color: "blue" }),
                    fetchScroolDataList.map(function (item, index) {
                        return (React__default['default'].createElement("li", { className: index === schoolDataActive ? 'actived' : '', key: item.term, dangerouslySetInnerHTML: { __html: item.term }, onClick: function () {
                                fetchSchoolDetail(item.term);
                                removeSchoolDataList();
                            } }));
                    })),
            // 暂无数据
            onFocus && (React__default['default'].createElement("div", { className: "empty-item" }, emptyMessage))),
        React__default['default'].createElement(GlobalStyle, null)));
};
SchoolSelect.defaultProps = {
    emptyMessage: '暂无搜索结果，请更换搜索关键词。',
};

var CascadeContent = styled__default['default'].div(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  position: relative;\n  &.no-hover{\n    .i-content{\n      input{\n        cursor: default;\n      } \n    }\n  }\n  .i-content{\n    input{\n      cursor: pointer;\n    } \n  }\n  .select-box{\n    background-color: #fff;\n    position: absolute;\n    display: none;\n    top: 40px;\n    left: 0;\n    width: 100%;\n    .row-box{\n      width: 100%;\n      border: 1px solid #ccc;\n      overflow: hidden;\n      ul{\n        width: 100%;\n        float: left;\n        font-size: 12px;\n      }\n      li{\n        cursor: pointer;\n        padding: 6px 10px;\n        line-height: 1.5;\n        &:hover{\n          background: #f8f8f8;\n        }\n        &.actived{\n          background-color: #0d6efd;\n          color: #fff;\n        }\n      }\n      &.first-row{\n        ul{\n          max-height: 250px;\n          overflow-y: auto;\n          li{\n            text-align: center;\n          }\n        }\n      }\n      &.second-row{\n        ul{\n          width: 50%;\n          height: 250px;\n          overflow-y: auto;\n          &:nth-child(1){\n            border-right: 1px solid #ccc;\n          }\n        }\n      }\n      &.third-row{\n        ul{\n          width: 33.33333%;\n          height: 250px;\n          overflow-y: auto;\n          &:nth-child(1),\n          &:nth-child(2){\n            border-right: 1px solid #ccc;\n          }\n          &:nth-child(2){\n            background-color: #fafafa;\n          }\n        }\n      }\n    }\n  }\n  &.is-show{\n    .select-box{\n      display: block;\n    }\n  }\n"], ["\n  position: relative;\n  &.no-hover{\n    .i-content{\n      input{\n        cursor: default;\n      } \n    }\n  }\n  .i-content{\n    input{\n      cursor: pointer;\n    } \n  }\n  .select-box{\n    background-color: #fff;\n    position: absolute;\n    display: none;\n    top: 40px;\n    left: 0;\n    width: 100%;\n    .row-box{\n      width: 100%;\n      border: 1px solid #ccc;\n      overflow: hidden;\n      ul{\n        width: 100%;\n        float: left;\n        font-size: 12px;\n      }\n      li{\n        cursor: pointer;\n        padding: 6px 10px;\n        line-height: 1.5;\n        &:hover{\n          background: #f8f8f8;\n        }\n        &.actived{\n          background-color: #0d6efd;\n          color: #fff;\n        }\n      }\n      &.first-row{\n        ul{\n          max-height: 250px;\n          overflow-y: auto;\n          li{\n            text-align: center;\n          }\n        }\n      }\n      &.second-row{\n        ul{\n          width: 50%;\n          height: 250px;\n          overflow-y: auto;\n          &:nth-child(1){\n            border-right: 1px solid #ccc;\n          }\n        }\n      }\n      &.third-row{\n        ul{\n          width: 33.33333%;\n          height: 250px;\n          overflow-y: auto;\n          &:nth-child(1),\n          &:nth-child(2){\n            border-right: 1px solid #ccc;\n          }\n          &:nth-child(2){\n            background-color: #fafafa;\n          }\n        }\n      }\n    }\n  }\n  &.is-show{\n    .select-box{\n      display: block;\n    }\n  }\n"])));
var templateObject_1$2;

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "/* ZoomIn */\n.zoomIn-enter {\n  opacity: 0;\n  transform: scale(0.9);\n}\n.zoomIn-enter-active {\n  opacity: 1;\n  transform: translateX(0);\n  transition: opacity .3s, transform .3s;\n  transform-origin: center center;\n}\n.zoomIn-exit {\n  opacity: 1;\n}\n.zoomIn-exit-active {\n  opacity: 0;\n  transform: scale(0.9);\n  transition: opacity .3s, transform .3s;\n  transform-origin: center center;\n}\n\n/* FadeInDown */\n.fadeInDown-enter{\n  opacity: 0;\n}\n.fadeInDown-enter-active{\n  opacity: 1;\n  animation-name: fadeInDown;\n  -webkit-animation-duration: .3s;\n  animation-duration: .3s;\n  -webkit-animation-fill-mode: both;\n  animation-fill-mode: both;\n}\n.fadeInDown-exit{\n  opacity: 1;\n  animation-name: fadeOutUp;\n  -webkit-animation-duration: .3s;\n  animation-duration: .3s;\n  -webkit-animation-fill-mode: both;\n  animation-fill-mode: both;\n  /* -webkit-animation-duration: 2s;\n  animation-duration: 2s;\n  -webkit-animation-name: hinge;\n  animation-name: hinge; */\n}\n.fadeInDown-active{\n  opacity: 0;\n}\n@keyframes fadeInDown {\n  from {\n    opacity: 0;\n    -webkit-transform: translate3d(0, -20%, 0);\n    transform: translate3d(0, -20%, 0);\n  }\n  to {\n    opacity: 1;\n    -webkit-transform: translate3d(0, 0, 0);\n    transform: translate3d(0, 0, 0);\n  }\n}\n@keyframes fadeOutUp {\n  from {\n    opacity: 1;\n  }\n  to {\n    opacity: 0;\n    -webkit-transform: translate3d(0, -20%, 0);\n    transform: translate3d(0, -20%, 0);\n  }\n}\n\n@keyframes hinge {\n  /*像右侧的钉子掉了，相框掉到了地上；*/\n  0% {\n    -webkit-transform-origin: top left;\n    transform-origin: top left;\n    -webkit-animation-timing-function: ease-in-out;\n    animation-timing-function: ease-in-out;\n  }\n\n  20%,\n  60% {\n    -webkit-transform: rotate3d(0, 0, 1, 80deg);\n    transform: rotate3d(0, 0, 1, 80deg);\n    -webkit-transform-origin: top left;\n    transform-origin: top left;\n    -webkit-animation-timing-function: ease-in-out;\n    animation-timing-function: ease-in-out;\n  }\n\n  40%,\n  80% {\n    -webkit-transform: rotate3d(0, 0, 1, 60deg);\n    transform: rotate3d(0, 0, 1, 60deg);\n    -webkit-transform-origin: top left;\n    transform-origin: top left;\n    -webkit-animation-timing-function: ease-in-out;\n    animation-timing-function: ease-in-out;\n    opacity: 1;\n  }\n\n  to {\n    -webkit-transform: translate3d(0, 700px, 0);\n    transform: translate3d(0, 700px, 0);\n    opacity: 0;\n  }\n}\n\n/*  */";
styleInject(css_248z);

var Transition = function (props) {
    var transition = props.transition, wrapple = props.wrapple, classNames = props.classNames, children = props.children, restProps = __rest(props, ["transition", "wrapple", "classNames", "children"]);
    return (React__default['default'].createElement(reactTransitionGroup.CSSTransition, __assign({}, restProps, { classNames: transition || classNames }), wrapple ? React__default['default'].createElement("div", null, children) : children));
};
Transition.defaultProps = {
    appear: true,
    unmountOnExit: true,
};

var CascadeSelect = function (props) {
    var _a, _b, _c;
    var className = props.className, style = props.style, dataApi = props.dataApi, disabled = props.disabled; props.onSelect; var col = props.col, selectContentStyle = props.selectContentStyle, onSelectCallback = props.onSelectCallback, defaultValue = props.defaultValue, transition = props.transition, timeout = props.timeout, restProps = __rest(props, ["className", "style", "dataApi", "disabled", "onSelect", "col", "selectContentStyle", "onSelectCallback", "defaultValue", "transition", "timeout"]);
    var _d = React.useState(false), isShow = _d[0], setIsShow = _d[1]; // 下拉菜单开关
    var _e = React.useState((defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.label) || ''), inputValue = _e[0], setInputValue = _e[1]; // 选中的文字
    var _f = React.useState(-100), oneActiveIndex = _f[0], setOneActiveIndex = _f[1]; // 第一列选中 index
    var _g = React.useState(-100), twoActiveIndex = _g[0], setTwoActiveIndex = _g[1]; // 第二列选中 index
    var classes = classNames__default['default'](className, {
        'is-show': isShow,
        'no-hover': disabled,
    });
    React.useEffect(function () {
        // console.log(dataApi);
        document.addEventListener('click', function (e) {
            setIsShow(false);
        });
    }, []);
    // 根据 prop col 设置列数样式
    var setRowBoxClasses = classNames__default['default']('row-box', {
        'first-row': col === 1,
        'second-row': col == 2,
        'third-row': col === 3,
    });
    // 生成 li
    var renderItem = function (data, activeIndex, callback) {
        if (data && data.length > 0) {
            return data.map(function (item, index) { return (React__default['default'].createElement("li", { className: index === activeIndex ? 'actived' : '', onClick: function (e) {
                    e.nativeEvent.stopImmediatePropagation();
                    callback(item, index);
                }, key: item.value }, item.label)); });
        }
    };
    // 第一列事件
    var firstCallback = function (item, i) {
        if (col && col > 1) {
            setOneActiveIndex(i);
        }
        else {
            setInputValue(item.label);
            onSelectCallback(item);
            initState();
        }
    };
    var initState = function () {
        setIsShow(false);
        setOneActiveIndex(-100);
        setTwoActiveIndex(-100);
    };
    var secondCallback = function (item, i) {
        if (col && col > 2) {
            setTwoActiveIndex(i);
        }
        else {
            var value = dataApi && dataApi[oneActiveIndex].label;
            setInputValue(value + " " + item.label);
            onSelectCallback(item);
            initState();
        }
    };
    var thirdCallback = function (item, i) {
        if (col && col > 3) ;
        else {
            var valueOne = dataApi && dataApi[oneActiveIndex].label;
            var valueTwo = dataApi && dataApi[oneActiveIndex].children[twoActiveIndex].label;
            setInputValue(valueOne + " " + valueTwo + " " + item.label);
            onSelectCallback(item);
            initState();
        }
    };
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement(CascadeContent, { className: classes, style: style },
            React__default['default'].createElement(Input, __assign({ value: inputValue, disabled: disabled, onClick: function (e) {
                    e.stopPropagation();
                    if (!disabled) {
                        setIsShow(true);
                    }
                } }, restProps)),
            React__default['default'].createElement(Transition, { addEndListener: function () { }, transition: transition, in: isShow, timeout: timeout },
                React__default['default'].createElement("div", { className: "select-box", style: selectContentStyle },
                    React__default['default'].createElement("div", { className: setRowBoxClasses },
                        React__default['default'].createElement("ul", { className: "rol-box" }, renderItem(dataApi, oneActiveIndex, function (item, index) { return firstCallback(item, index); })),
                        col && col >= 2 && oneActiveIndex !== -100 && (React__default['default'].createElement("ul", { className: "rol-box" }, renderItem(dataApi && ((_a = dataApi[oneActiveIndex]) === null || _a === void 0 ? void 0 : _a.children), twoActiveIndex, function (item, index) { return secondCallback(item, index); }))),
                        col && col >= 3 && oneActiveIndex !== -100 && twoActiveIndex !== -100 && (React__default['default'].createElement("ul", { className: "rol-box" }, renderItem(dataApi && ((_c = (_b = dataApi[oneActiveIndex]) === null || _b === void 0 ? void 0 : _b.children[twoActiveIndex]) === null || _c === void 0 ? void 0 : _c.children), -100, function (item, index) { return thirdCallback(item); })))),
                    React__default['default'].createElement("div", { style: { clear: 'both', height: '0px', fontSize: '0px', overflow: 'hidden' } })))),
        React__default['default'].createElement(GlobalStyle, null)));
};
CascadeSelect.defaultProps = {
    col: 1,
    transition: 'zoomIn',
    timeout: 0,
};

var DatePickerContent = styled__default['default'].div(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  position: relative;\n  .select-box{\n    position: absolute;\n    z-index: 9;\n    left:0;\n    top: 40px;\n    height: 198px;\n    width: 100%;\n    overflow: hidden;\n    display: none;\n    background-color: #fff;\n    border: 1px solid #ccc;\n    .row-box{\n      height: 198px;\n      display: flex;\n      flex-direction: row;\n      ul{\n        max-height: 198px;\n        border-right: 1px solid #f1f1f1;\n        li{\n          cursor: pointer;\n          &:hover{\n            background-color: #f8f8f8;\n          }\n          &.actived{\n            background-color: #0d6efd;\n            color: #fff;\n          }\n        }\n        &:nth-child(1),\n        &:nth-child(3){\n          overflow-y: auto;\n          li {\n            width: 80px;\n            height: 36px;\n            line-height: 36px;\n            text-align: center;\n\n          }\n        }\n        &:nth-child(2){\n          flex: 1;\n          display: flex;\n          flex-direction: row;\n          flex-wrap: wrap;\n          &.disabled{\n            opacity: .3;\n            li{\n              cursor: default;\n              &:hover{\n                background: transparent;\n              }\n            }\n          }\n          li{\n            height:48px;\n            width: 33.333333%;\n            line-height: 48px;\n            text-align: center;\n          }\n        }\n        &:nth-child(3){\n          &.disabled{\n            opacity: .3;\n            li{\n              cursor: default;\n              &:hover{\n                background: transparent;\n              }\n            }\n          }\n        }\n        &:last-child{\n          /* border-right: none; */\n        }\n      }\n    }\n  }\n  &.no-hover{\n    .i-content{\n      input{\n        cursor: default;\n      } \n    }\n  }\n  .i-content{\n    input{\n      cursor: pointer;\n    } \n  }\n  &.is-show{\n    .select-box{\n      display: block;\n    }\n  }\n"], ["\n  position: relative;\n  .select-box{\n    position: absolute;\n    z-index: 9;\n    left:0;\n    top: 40px;\n    height: 198px;\n    width: 100%;\n    overflow: hidden;\n    display: none;\n    background-color: #fff;\n    border: 1px solid #ccc;\n    .row-box{\n      height: 198px;\n      display: flex;\n      flex-direction: row;\n      ul{\n        max-height: 198px;\n        border-right: 1px solid #f1f1f1;\n        li{\n          cursor: pointer;\n          &:hover{\n            background-color: #f8f8f8;\n          }\n          &.actived{\n            background-color: #0d6efd;\n            color: #fff;\n          }\n        }\n        &:nth-child(1),\n        &:nth-child(3){\n          overflow-y: auto;\n          li {\n            width: 80px;\n            height: 36px;\n            line-height: 36px;\n            text-align: center;\n\n          }\n        }\n        &:nth-child(2){\n          flex: 1;\n          display: flex;\n          flex-direction: row;\n          flex-wrap: wrap;\n          &.disabled{\n            opacity: .3;\n            li{\n              cursor: default;\n              &:hover{\n                background: transparent;\n              }\n            }\n          }\n          li{\n            height:48px;\n            width: 33.333333%;\n            line-height: 48px;\n            text-align: center;\n          }\n        }\n        &:nth-child(3){\n          &.disabled{\n            opacity: .3;\n            li{\n              cursor: default;\n              &:hover{\n                background: transparent;\n              }\n            }\n          }\n        }\n        &:last-child{\n          /* border-right: none; */\n        }\n      }\n    }\n  }\n  &.no-hover{\n    .i-content{\n      input{\n        cursor: default;\n      } \n    }\n  }\n  .i-content{\n    input{\n      cursor: pointer;\n    } \n  }\n  &.is-show{\n    .select-box{\n      display: block;\n    }\n  }\n"])));
var templateObject_1$1;

var selectYear = '';
var selectMonth = '';
var DatePicker = function (props) {
    var transition = props.transition, timeout = props.timeout, className = props.className, style = props.style, dateType = props.dateType, defaultValue = props.defaultValue, disabled = props.disabled, onSelectCallback = props.onSelectCallback, hasDay = props.hasDay, restProps = __rest(props, ["transition", "timeout", "className", "style", "dateType", "defaultValue", "disabled", "onSelectCallback", "hasDay"]);
    var _a = React.useState(false), isShow = _a[0], setIsShow = _a[1]; // 下拉层开关
    var _b = React.useState(defaultValue || ''), inputValue = _b[0], setInputValue = _b[1];
    var _c = React.useState(-100), oneActiveIndex = _c[0], setOneActiveIndex = _c[1]; // 年份当前选中状态
    var _d = React.useState(-100), twoActiveIndex = _d[0], setTwoActiveIndex = _d[1]; // 月份选中状态
    var _e = React.useState(30), fetchDays = _e[0], setFetchDays = _e[1];
    var claaes = classNames__default['default'](className, {
        'is-show': isShow === true,
        'no-hover': disabled,
    });
    var mouthHaveDays = function (date) {
        // 获取月份的总天数
        var curDate = date ? new Date(date) : new Date();
        var year = curDate.getFullYear();
        var month = curDate.getMonth() + 1;
        var d = new Date(year, month, 0);
        return d.getDate();
    };
    // 年份渲染函数
    var renderYear = function () {
        var year = new Date().getFullYear();
        var arr = [];
        if (dateType === 'now') {
            arr.push('至今');
        }
        if (dateType === 'gTime') {
            year += 5;
        }
        for (var i = year; i >= 1966; i--) {
            arr.push(i);
        }
        var renderItem = arr.map(function (item, index) {
            var liCalss = classNames__default['default']({
                actived: index === oneActiveIndex,
            });
            var yearHandelClick = function (e) {
                e.stopPropagation();
                if (item === 'now' || item === '至今' || item === 'NOW') {
                    setInputValue(item);
                    onSelectCallback && onSelectCallback(item.toString());
                    resetState();
                }
                else {
                    setOneActiveIndex(index);
                    selectYear = item.toString();
                }
            };
            return (React__default['default'].createElement("li", { onClick: function (e) { return yearHandelClick(e); }, className: liCalss, key: item }, item));
        });
        return React__default['default'].createElement("ul", null, renderItem);
    };
    // 月份渲染函数
    var renderMonth = function () {
        var arr = [];
        for (var i = 1; i <= 12; i++) {
            arr.push(i < 10 ? "0" + i : i);
        }
        var setMonthClass = classNames__default['default']({
            'disabled': oneActiveIndex === -100,
        });
        var renderItem = arr.map(function (item, index) {
            var monthHandelClcik = function (e) {
                e.stopPropagation();
                if (oneActiveIndex !== -100) {
                    selectMonth = item.toString();
                    if (hasDay) {
                        setTwoActiveIndex(index);
                    }
                    else {
                        selectMonth = item.toString();
                        setInputValue(selectYear + "-" + selectMonth);
                        resetState();
                        onSelectCallback && onSelectCallback(selectYear + "-" + selectMonth);
                    }
                }
            };
            var setClassName = classNames__default['default']({
                'actived': index === twoActiveIndex,
            });
            return (React__default['default'].createElement("li", { className: setClassName, onClick: function (e) { return monthHandelClcik(e); }, key: item }, item));
        });
        return React__default['default'].createElement("ul", { className: setMonthClass }, renderItem);
    };
    React.useEffect(function () {
        console.log(selectYear);
        console.log(selectMonth);
        if (selectYear && selectMonth) {
            var day = mouthHaveDays(selectYear + "-" + selectMonth);
            setFetchDays(day);
        }
    }, [twoActiveIndex]);
    React.useEffect(function () {
        document.addEventListener('click', function (e) {
            setIsShow(false);
        });
    }, []);
    // 天渲染函数
    var renderDays = function () {
        var arr = [];
        for (var i = 1; i <= fetchDays; i++) {
            arr.push(i < 10 ? "0" + i : "" + i);
        }
        var setClassName = classNames__default['default']({
            disabled: twoActiveIndex === -100,
        });
        var renderItem = arr.map(function (item) {
            var dayHandelClick = function (e) {
                e.stopPropagation();
                if (twoActiveIndex !== -100) {
                    var value = selectYear + "-" + selectMonth + "-" + item;
                    setInputValue(value);
                    onSelectCallback && onSelectCallback(value);
                    resetState();
                }
            };
            return React__default['default'].createElement("li", { onClick: function (e) { return dayHandelClick(e); }, key: item }, item);
        });
        return React__default['default'].createElement("ul", { className: setClassName }, renderItem);
    };
    // 重置 State
    var resetState = function () {
        setOneActiveIndex(-100);
        setTwoActiveIndex(-100);
        setIsShow(false);
    };
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement(DatePickerContent, { className: claaes, style: style },
            React__default['default'].createElement(Input, __assign({ onClick: function (e) {
                    e.nativeEvent.stopImmediatePropagation();
                    setIsShow(true);
                }, value: inputValue, disabled: disabled }, restProps)),
            React__default['default'].createElement(Transition, { addEndListener: function () { }, transition: transition, in: isShow, timeout: timeout },
                React__default['default'].createElement("div", { className: "select-box" },
                    React__default['default'].createElement("div", { className: "row-box" },
                        renderYear(),
                        renderMonth(),
                        hasDay && renderDays())))),
        React__default['default'].createElement(GlobalStyle, null)));
};
DatePicker.defaultProps = {
    transition: 'zoomIn',
    timeout: 0,
};

var ModalContent = styled__default['default'].div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: fixed;\n  top: 0; \n  right: 0;\n  left: 0;\n  bottom: 0;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  z-index: 100;\n  .mask {\n    position: absolute;\n    top: 0;\n    right: 0;\n    left: 0;\n    bottom: 0;\n    z-index: 99;\n  }\n  .modal-content {\n    position: relative;\n    z-index: 100;\n    padding: 20px;\n    background-color: #fff;\n    box-shadow: 0 0 5px rgba(0, 0, 0, 0.3);\n    .closeBtn {\n      position: absolute;\n      top: -10px;\n      cursor: pointer;\n      right: -10px;\n      width: 34px;\n      height: 34px;\n      border-radius: 50%;\n      background: rgb(244, 244, 244);\n      box-shadow: rgb(255 255 255) 0px 0px 0px 6px;\n      &::before {\n        position: absolute;\n        left: 9px;\n        top: 6px;\n        content: '\u00D7';\n        display: inline-block;\n        font-size: 28px;\n        font-weight: bold;\n        color: #3c64b1;\n        opacity: 0.8;\n      }\n      &:hover::before {\n        opacity: 1;\n      }\n    }\n  }\n  .buttons {\n    width: 100%;\n    text-align: center;\n    button {\n      margin: 15px 10px 0;\n      /* &:nth-child(2) {\n        background-color: #3c64b1;\n        color: #fff;\n      } */\n    }\n  }\n"], ["\n  position: fixed;\n  top: 0; \n  right: 0;\n  left: 0;\n  bottom: 0;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  z-index: 100;\n  .mask {\n    position: absolute;\n    top: 0;\n    right: 0;\n    left: 0;\n    bottom: 0;\n    z-index: 99;\n  }\n  .modal-content {\n    position: relative;\n    z-index: 100;\n    padding: 20px;\n    background-color: #fff;\n    box-shadow: 0 0 5px rgba(0, 0, 0, 0.3);\n    .closeBtn {\n      position: absolute;\n      top: -10px;\n      cursor: pointer;\n      right: -10px;\n      width: 34px;\n      height: 34px;\n      border-radius: 50%;\n      background: rgb(244, 244, 244);\n      box-shadow: rgb(255 255 255) 0px 0px 0px 6px;\n      &::before {\n        position: absolute;\n        left: 9px;\n        top: 6px;\n        content: '\u00D7';\n        display: inline-block;\n        font-size: 28px;\n        font-weight: bold;\n        color: #3c64b1;\n        opacity: 0.8;\n      }\n      &:hover::before {\n        opacity: 1;\n      }\n    }\n  }\n  .buttons {\n    width: 100%;\n    text-align: center;\n    button {\n      margin: 15px 10px 0;\n      /* &:nth-child(2) {\n        background-color: #3c64b1;\n        color: #fff;\n      } */\n    }\n  }\n"])));
var Modal = function (props) {
    var children = props.children, visible = props.visible, width = props.width, height = props.height, hideCloseBtn = props.hideCloseBtn, opcity = props.opcity, className = props.className, buttons = props.buttons, transition = props.transition, closeBtnClick = props.closeBtnClick, buttonClick = props.buttonClick;
    var inputEl = React.useRef(null);
    React.useEffect(function () {
        if (visible === false) {
            if (inputEl.current !== null) {
                inputEl.current.style.display = 'none';
            }
            // setTimeout(() => {
            //   if (inputEl.current !== null) {
            //     inputEl.current.style.display = 'none';
            //   }
            // }, 200);
        }
        else if (inputEl.current !== null)
            inputEl.current.style.display = 'flex';
    }, [visible]);
    var setButtonType = function (index) {
        if (index === 0)
            return 'light';
    };
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement(ModalContent, { ref: inputEl, className: className },
            visible && (React__default['default'].createElement("div", { className: "mask", style: { backgroundColor: "rgba(0, 0, 0, " + opcity + ")" } })),
            React__default['default'].createElement(Transition, { addEndListener: function () { }, in: visible, timeout: 300, transition: transition },
                React__default['default'].createElement("div", { className: "modal-content", style: { width: width + "px", height: height + "px" } },
                    !hideCloseBtn && (React__default['default'].createElement("div", { role: "button", className: "closeBtn", onClick: closeBtnClick, tabIndex: 0, onKeyDown: closeBtnClick })),
                    children,
                    React__default['default'].createElement("div", { className: "buttons" }, buttons &&
                        buttons.length > 0 &&
                        buttons.map(function (item, index) { return (React__default['default'].createElement(Button, { buttonType: setButtonType(index), key: item, onClick: function () {
                                if (buttonClick) {
                                    buttonClick(index);
                                }
                            } }, item)); }))))),
        React__default['default'].createElement(GlobalStyle, null)));
};
Modal.defaultProps = {
    opcity: 0.3,
    buttons: [],
    transition: 'zoomIn',
};
var templateObject_1;

exports.Breadcrumbs = Breadcrumbs;
exports.Bubble = Bubble;
exports.Button = Button;
exports.Card = Card;
exports.CascadeSelect = CascadeSelect;
exports.DatePicker = DatePicker;
exports.Icon = Icon;
exports.Image = Image;
exports.Input = Input;
exports.Menu = Menu;
exports.Modal = Modal;
exports.NoContent = NoContent;
exports.Radio = Raido;
exports.SchoolSelect = SchoolSelect;
exports.Steps = Steps;
exports.Tabs = TransTabs;
exports.Transition = Transition;
//# sourceMappingURL=index.js.map
